/*
 * not working PID controller
 */

char motor1 = 9;
char motor2 = 10;
char slider = A0;
const float Kr = 1.95; // gain proportionnel.
float yi[2] = { 0.0, 0.0 }; // filtre passe-bas 1.
float ki[2];
float yd[2] = { 0.0, 0.0 }; // filtre passe-bas 2.
float kd[2];
int target = 500; // consigne.

float lpf(int sample, float coeffs[], float y[])
{
  y[0] = coeffs[1]*sample + coeffs[0]*y[1];
  y[1] = y[0]; // retard d’un echantillon.
  return y[0];
}

void setup(void)
{
  pinMode(motor1,OUTPUT);
  digitalWrite(motor1,LOW);
  pinMode(motor2,OUTPUT);
  digitalWrite(motor2,LOW);
  pinMode(slider,INPUT);
}

void loop(void)
{
  int error;
  float spd_p;
  float spd_d;
  float spd_i;
  int spd;

  int val = analogRead(slider);

  // calcule l’erreur.
  error = target - val;

  // calcule la partie proportionnelle (P).
  spd_p = error*Kr;
  // calcule la partie integrale (I).
  spd_i = lpf(error,ki,yi);
  // calcule la partie differentielle (D).
  spd_d = error - lpf(error,kd,yd);
  // additionne P, I & D.
  spd = spd_p + spd_i + spd_d;

  if (spd<0)
  {
    // Sens horaire.
    digitalWrite(motor1,HIGH);
    analogWrite(motor2,-spd);
  }
  else
  {
    // Sens antihoraire.
    digitalWrite(motor2,HIGH);
    analogWrite(motor1,spd);
  }
}

